"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _os = require("os");

var _path = require("path");

var _configFile = require("../config-file");

var _cloudLinkError = _interopRequireDefault(require("../cloud-link-error"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = (...links) => {
  const badLink = links.find(({
    name,
    src,
    dest
  }) => typeof name !== 'string' || typeof src !== 'string' || typeof dest !== 'string');

  if (badLink || !links.length) {
    throw new TypeError('name, src and dest must be of type string');
  }

  return (0, _configFile.get)().then(data => {
    const newLinks = links.reduce((links, {
      name,
      src,
      dest
    }) => {
      const link = links[name] || {
        src,
        dest: {}
      };

      if (link.src !== src) {
        throw new _cloudLinkError.default('Trying to add conflicting links. try to remove the link first.');
      }

      link.dest[(0, _os.hostname)()] = (0, _path.resolve)(dest);
      return _objectSpread({}, links, {
        [name]: link
      });
    }, data.links);
    return (0, _configFile.set)(_objectSpread({}, data, {
      links: newLinks
    }));
  });
};

exports.default = _default;
//# sourceMappingURL=add.js.map