"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _fs = require("fs");

var _os = require("os");

var _path = require("path");

var _lnfs = _interopRequireDefault(require("lnfs"));

var _pify = _interopRequireDefault(require("pify"));

var _store = _interopRequireDefault(require("../store"));

var _list = _interopRequireDefault(require("./list"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const statP = (0, _pify.default)(_fs.stat);

var _default = (...names) => (0, _list.default)().then(links => {
  const applyLinks = names.length ? links.filter(({
    name
  }) => names.includes(name)) : links;
  return Promise.all(applyLinks.map(link => _objectSpread({}, link, {
    src: (0, _path.resolve)(_store.default.get('cloudPath'), link.src),
    dest: link.dest[(0, _os.hostname)()]
  })).filter(({
    dest
  }) => dest).map(({
    src,
    dest,
    name
  }) => statP(src).then(stats => stats.isDirectory() ? 'junction' : 'file').then(type => (0, _lnfs.default)(src, dest, type)).then(() => ({
    name,
    src,
    dest,
    status: 'linked'
  })).catch(error => ({
    name,
    src,
    dest,
    error,
    status: error.code !== 'ENOENT' ? 'error' : 'missing'
  }))));
});

exports.default = _default;
//# sourceMappingURL=apply.js.map