"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _os = require("os");

var _lodash = _interopRequireDefault(require("lodash"));

var _configFile = require("../config-file");

var _cloudLinkError = _interopRequireDefault(require("../cloud-link-error"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = (...links) => {
  const badLink = links.find(({
    name,
    all = false
  }) => typeof name !== 'string' || typeof all !== 'boolean');

  if (badLink || !links.length) {
    throw new TypeError('name must be of type string and all must be of type boolean');
  }

  return (0, _configFile.get)().then(data => {
    const newLinks = links.reduce((links, {
      name,
      all
    }) => {
      if (!links[name]) {
        throw new _cloudLinkError.default(`Trying to remove link named '${name}' but none were found.`);
      }

      if (all) {
        delete links[name];
        return _objectSpread({}, links);
      }

      delete links[name].dest[(0, _os.hostname)()];

      if (_lodash.default.isEmpty(links[name].dest)) {
        delete links[name];
      }

      return _objectSpread({}, links);
    }, data.links);
    return (0, _configFile.set)(_objectSpread({}, data, {
      links: newLinks
    }));
  });
};

exports.default = _default;
//# sourceMappingURL=remove.js.map