"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _os = require("os");

var _path = require("path");

var _fs = _interopRequireDefault(require("fs"));

var _pify = _interopRequireDefault(require("pify"));

var _pCatchIf = _interopRequireDefault(require("p-catch-if"));

var _lodash = _interopRequireDefault(require("lodash"));

var _store = _interopRequireDefault(require("../store"));

var _list = _interopRequireDefault(require("./list"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const {
  lstat,
  realpath
} = (0, _pify.default)(_fs.default);

var _default = (...names) => (0, _list.default)().then(links => {
  const statusLinks = names.length ? links.filter(({
    name
  }) => names.includes(name)) : links;
  const localLinks = statusLinks.filter(({
    dest
  }) => dest[(0, _os.hostname)()]);
  return Promise.all(localLinks.map(({
    dest,
    src,
    name
  }) => {
    const resolvedSrc = (0, _path.resolve)(_store.default.get('cloudPath'), src);
    const resolvedDest = (0, _path.resolve)(dest[(0, _os.hostname)()]);
    return lstat(resolvedDest).then(stats => {
      if (!stats.isSymbolicLink()) {
        return 'unlinked';
      }

      return realpath(resolvedDest).then(res => res !== resolvedSrc ? 'wrong' : 'linked');
    }).catch((0, _pCatchIf.default)(err => err.code === 'ENOENT', _lodash.default.constant('missing'))).then(status => ({
      status,
      src: resolvedSrc,
      dest: resolvedDest,
      name
    }));
  }));
});

exports.default = _default;
//# sourceMappingURL=status.js.map