"use strict";

var _caporal = require("caporal");

var _util = require("../util");

var _ = require("../..");

(0, _util.registerCommand)({
  initialization: true,
  name: 'clean',
  description: 'Delete all configured links',
  opts: [['-f, --force', 'force clean', _caporal.BOOL, false]],

  action({
    logger,
    options: {
      force
    }
  }) {
    return (0, _util.askConfirmation)({
      shouldAsk: !force,
      message: 'Are you sure that you want to delete all configured links?',

      async action() {
        await (0, _.clean)();
        logger.info('Cloud link cleaned successfully!');
      }

    });
  }

});
//# sourceMappingURL=clean.js.map