"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clean = exports.set = exports.get = exports.getPath = exports.defaultTemplate = exports.defaultConfigName = void 0;

var _path = require("path");

var _fs = _interopRequireDefault(require("fs"));

var _jsonfile = _interopRequireDefault(require("jsonfile"));

var _pify = _interopRequireDefault(require("pify"));

var _lodash = _interopRequireDefault(require("lodash"));

var _pCatchIf = _interopRequireDefault(require("p-catch-if"));

var _store = _interopRequireDefault(require("./store"));

var _cloudLinkError = _interopRequireDefault(require("./cloud-link-error"));

var _initialized = _interopRequireDefault(require("./actions/initialized"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const jf = (0, _pify.default)(_jsonfile.default);
const fsP = (0, _pify.default)(_fs.default);
const defaultConfigName = '.cloud-link.json';
exports.defaultConfigName = defaultConfigName;
const defaultTemplate = {
  links: {}
};
exports.defaultTemplate = defaultTemplate;

const getPath = () => {
  if (!(0, _initialized.default)()) {
    throw new _cloudLinkError.default('Cloud link not initialized');
  }

  return (0, _path.join)(_store.default.get('cloudPath'), defaultConfigName);
};

exports.getPath = getPath;

const get = () => jf.readFile(getPath()).catch((0, _pCatchIf.default)(err => err.code === 'ENOENT', () => _lodash.default.cloneDeep(defaultTemplate)));

exports.get = get;

const set = data => jf.writeFile(getPath(), data);

exports.set = set;

const clean = () => fsP.unlink(getPath());

exports.clean = clean;
//# sourceMappingURL=config-file.js.map